<%- include('../layouts/header') %>

  <div class="content-wrapper">
  <!-- Content Header (Page header) -->
    <section class="content-header">
      <h1>CẤU HÌNH THÔNG SỐ GAME </h1>
    </section>
    
    <section class="content">
      <div style="background-color: white;">
        <table id="tableItem" class="footable table table-stripped toggle-arrow-tiny" data-page-size="15">

          <thead>
            <tr style="font-weight: bolder;">
              <td style="font-weight: bolder;">ID</td>
              <td style="font-weight: bolder;">TYPE ITEM</td>
              <td style="font-weight: bolder;">NAME</td>
              <td style="font-weight: bolder;">MAXIMUM</td>
              <td style="font-weight: bolder;">PERCENT</td>
              <td style="font-weight: bolder;">SAVE</td>
              <td style="font-weight: bolder;">SPECIAL ITEM</td>
            </tr>
          </thead>

          <tbody>
            <% for (e of data) { %>
              <tr>
                  <td><%= e['id'] %></td>
                  <td>
                    <% if (e['type'] === 0) { %>
                      Quà
                    <% }else if (e['type'] === 1) { %>
                      Thẻ Cào
                    <% }else { %>
                      NONE
                    <% } %>
                  </td>
                  <td>
                    <p><%= e['name'] %></p>
                  </td>
                  <td>
                    <%= e['maximum'] %>
                  </td>
                  <td>
                    <%= e['percent'] %>
                  </td>
                  <td>
                    <p><%= e['save'] %></p>
                  </td>
                  <td>
                    <p><%= e['special_item'] %></p>
                  </td>
                  <td class="text-right">
                    <div class="btn-group">
                        <a href="#" class="editItem" data-id="<%= e['id'] %>" data-toggle="modal"
                            data-target="#modalEditItem">Edit</a>
                        <a href="#" class="deleteItem" data-id="<%= e['id'] %>"
                            style="margin-left: 20px">Delete</a>
                    </div>
                </td>
              </tr>
            <% } %>
          </tbody>

          <tfoot>
              <tr>
                  <td colspan="6" style="text-align: center;">
                      <button type="button" data-toggle="modal" data-target="#modalAddItem" class="btn btn-success">ADD</button>
                  </td>
              </tr>
          </tfoot>
      </table>
  
      <!-- THE MODAL ADD ITEM -->
      <div class="modal" id="modalAddItem">
          <div class="modal-dialog">
              <div class="modal-content">
  
                  <!-- Modal Header -->
                  <div class="modal-header">
                      <h4 class="modal-title" style="font-weight: bolder">ADD ITEM</h4>
                      <button type="button" class="close" data-dismiss="modal">&times;</button>
                  </div>
  
                  <!-- Modal body -->
                  <div class="modal-body">
                    <!-- ID-->
                    <div class="form-group">
                      <label class="col-md-4 control-label">ID</label>
                      <div class="col-md-12">
                          <input  id="idItem" placeholder="ID Item (unique)"
                                  class="form-control input-md" type="number"
                                  step="0" min="0">
                      </div>
                    </div>

                    <!-- TYPE ITEM -->
                    <div class="form-group">
                      <label class="col-md-4 control-label">TYPE ITEM</label>
                      <div class="col-md-12">
                        <select id="type-item">
                          <option value="choose">Choose Type Item</option>
                          <option value="-1">NONE</option>
                          <option value="0">Thẻ Cào</option>
                          <option value="1">Quà</option>
                        </select>
                      </div>
                    </div>

                    <!-- NAME-->
                    <div class="form-group">
                        <label class="col-md-12 control-label" for="product_name_fr">NAME ITEM</label>
                        <div class="col-md-12">
                            <input  id="nameItem" placeholder="Name item"
                                    class="form-control input-md" type="text">
                        </div>
                    </div>

                    <!-- MAXIMUM -->
                    <div class="form-group">
                      <label class="col-md-4 control-label">MAXIMUM</label>
                      <div class="col-md-12">
                          <input  id="maximumItem" placeholder="Maximum"
                                  class="form-control input-md" type="number"
                                  step="0" min="0">
                      </div>
                    </div>

                    <!-- PERCENT -->
                    <div class="form-group">
                      <label class="col-md-4 control-label">PERCENT</label>
                      <div class="col-md-12">
                          <input  id="percentItem" placeholder="Percent"
                                  class="form-control input-md" type="number"
                                  step="0" min="0">
                      </div>
                    </div>

                    <!-- SAVE -->
                    <div class="form-group">
                      <label class="col-md-4 control-label">SAVE ITEM</label>
                      <div class="col-md-12">
                        <select id="saveItem">
                          <option selected value="1">TRUE</option>
                          <option value="0">FALSE</option>
                        </select>
                      </div>
                    </div>

                    <!-- SPECIAL -->
                    <div class="form-group">
                      <label class="col-md-4 control-label">SPECIAL ITEM</label>
                      <div class="col-md-12">
                        <select id="specialItem">
                          <option value="1">TRUE</option>
                          <option selected value="0">FALSE</option>
                        </select>
                      </div>
                    </div>

                  <br>
                  <br>

                  <!-- Button -->
                  <div class="form-group">
                      <div class="col-md-12" style="text-align: center;">
                          <button id="btnAddItem" type="submit" name="singlebutton" class="btn btn-success">ADD</button>
                      </div>
                  </div>
                </div>
  
              </div>
          </div>
      </div>

      <!-- THE MODAL EDIT ITEM -->
      <div class="modal" id="modalEditItem">
        <div class="modal-dialog">
            <div class="modal-content">

                <!-- Modal Header -->
                <div class="modal-header">
                    <h4 class="modal-title" style="font-weight: bolder">EDIT ITEM</h4>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>

                <!-- Modal body -->
                <div class="modal-body">
                  <!-- ID-->
                  <div class="form-group">
                    <label class="col-md-4 control-label">ID</label>
                    <div class="col-md-12">
                      <p id="edtIdItem">10</p>
                    </div>
                  </div>

                  <!-- TYPE ITEM -->
                  <div class="form-group">
                    <label class="col-md-4 control-label">TYPE ITEM</label>
                    <div class="col-md-12">
                      <p id="edtTypeItem">Quà</p>
                    </div>
                  </div>

                  <!-- NAME-->
                  <div class="form-group">
                      <label class="col-md-12 control-label" for="product_name_fr">NAME ITEM</label>
                      <div class="col-md-12">
                          <input  id="edtNameItem" placeholder="Name item"
                                  class="form-control input-md" type="text">
                      </div>
                  </div>

                  <!-- MAXIMUM -->
                  <div class="form-group">
                    <label class="col-md-4 control-label">MAXIMUM</label>
                    <div class="col-md-12">
                        <input  id="edtMaximumItem" placeholder="Maximum"
                                class="form-control input-md" type="number"
                                step="0" min="0">
                    </div>
                  </div>

                  <!-- PERCENT -->
                  <div class="form-group">
                    <label class="col-md-4 control-label">PERCENT</label>
                    <div class="col-md-12">
                        <input  id="edtPercentItem" placeholder="Percent"
                                class="form-control input-md" type="number"
                                step="0" min="0">
                    </div>
                  </div>

                  <!-- SAVE -->
                  <div class="form-group">
                    <label class="col-md-4 control-label">SAVE ITEM</label>
                    <div class="col-md-12">
                      <!-- <select id="edtSaveItem">
                        <option selected value="1">TRUE</option>
                        <option value="0">FALSE</option>
                      </select> -->
                      <p id="edtSaveItem"></p>
                    </div>
                  </div>

                  <!-- SPECIAL -->
                  <div class="form-group">
                    <label class="col-md-4 control-label">SPECIAL ITEM</label>
                    <div class="col-md-12">
                      <!-- <select id="edtSpecialItem">
                        <option selected value="1">TRUE</option>
                        <option value="0">FALSE</option>
                      </select> -->
                      <p id="edtSpecialItem"></p>
                    </div>
                  </div>

                <br>
                <br>

                <!-- Button -->
                <div class="form-group">
                    <div class="col-md-12" style="text-align: center;">
                        <button id="btnEditItem" type="submit" name="singlebutton" class="btn btn-success">UPDATE</button>
                    </div>
                </div>
              </div>

            </div>
        </div>
    </div>
    </section>

  </div>

  <script>

    $(document.body).ready(() => {

      clearValueInModal();
      addItem();
      deleteItem();
      getItemById();
      updateItem();
      
    });

    function addItem() {
      $('#btnAddItem').click(() => {
        let id            = $('#idItem').val();
        let type          = $('#type-item').val();
        let name          = $('#nameItem').val().trim();
        let maximum       = $('#maximumItem').val();
        let percent       = $('#percentItem').val();
        let save          = $('#saveItem').val() === '1' ? true : false;
        let special       = $('#specialItem').val() === '1' ? true : false;

        if (id === '' || name === '' || maximum === '' || percent === '' || type === '') {
          alert('Add item failed!');
          return;
        }

        let dataJson = {
          id      : id,
          type    : type,
          name    : name,
          maximum : maximum,
          percent : percent,
          save    : save,
          special : special
        }

        $.ajax({
          url             : 'http://' + window.location.host + '/api/v1/admin/setup/add-item',
          method          : 'POST',
          contentType     : 'application/json; charset=utf-8',
          data            : JSON.stringify(dataJson)
        })
          .done((data) => {
            
            if (data['status_code'] !== 2000) {
              alert(data['error']);
              return;
            }

            $("#modalAddItem").modal('hide');
            updateTableItem(data['lsItem']);

          })
          .fail(() => {

          });
        
      });
    }

    function clearValueInModal() {
      $(".modal").on("hidden.bs.modal", () => {
        $('#idItem').val('');
        $('#type-item').val('choose');
        $('#nameItem').val('');
        $('#maximumItem').val('');
        $('#percentItem').val('');
        $('#saveItem').val('1');
        $('#specialItem').val('0');
      });
    }

    function updateTableItem(data) {
      $('#tableItem tbody').remove();
      let markup = '<tbody>';
      for (let e of data) {
        let strType = 'NONE';
        if (e['type'] === 0) {
          strType = 'Quà';
        }
        else {
          strType = 'Thẻ Cào';
        }

        markup += `
          <tr>
            <td>${e['id']}</td>
            <td>
              <p>${strType}</p>
            </td>
            <td>
              <p>${e['name']}</p>
            </td>
            <td>
              <p>${e['maximum']}</p>
            </td>
            <td>
              <p>${e['percent']}</p>
            </td>
            <td>
              <p>${e['save']}</p>
            </td>
            <td>
              <p>${e['special_item']}</p>
            </td>
            <td class="text-right">
              <div class="btn-group">
                  <a href="#" class="editItem" data-id="${e['id']}" data-toggle="modal"
                      data-target="#modalEditItem">Edit</a>
                  <a href="#" class="deleteItem" data-id="${e['id']}"
                      style="margin-left: 20px">Delete</a>
              </div>
            </td>
          </tr>`;
      }
      markup += '</tbody>';
      $('#tableItem').append(markup);
    }

    function deleteItem() {
      $('body').delegate('.deleteItem', 'click', (event) => {
        let id      = event.currentTarget.attributes.getNamedItem('data-id').value;
        let itemJs  = {
          id  : id
        }

        $.ajax({
            url     : 'http://' + window.location.host + '/api/v1/admin/setup/delete-item',
            method  : 'POST',
            contentType : 'application/json; charset=utf-8',
            data        : JSON.stringify(itemJs)
          })
            .done((data) => {
              if (data['status_code'] !== 2000) {
                alert(data['error']);
                return;
              }
              updateTableItem(data['lsItemUpdate']);
            })
            .fail(() => {
              
            });
      });
    }
    
    function getItemById() {
      $('body').delegate('.editItem', 'click', (event) => {
        let id = event.currentTarget.attributes.getNamedItem('data-id').value;

        $.ajax({
          url     : 'http://' + window.location.host + '/api/v1/admin/setup/get-item-by-id',
          method  : 'POST',
          contentType : 'application/json; charset=utf-8',
          data        : JSON.stringify({
            id  : id
          })
        })
          .done((data) => {

            if (data['status_code'] !== 2000) {
              alert(data['error']);
              return;
            }

            let itemUpdate = data['item'];
            $('#edtIdItem').val(itemUpdate['id']);
            $('#edtNameItem').val(itemUpdate['name']);
            $('#edtMaximumItem').val(itemUpdate['maximum']);
            $('#edtPercentItem').val(itemUpdate['percent']);

            itemUpdate['save']          === true ? $('#edtSaveItem').text('TRUE') : $('#edtSaveItem').text('FALSE');
            itemUpdate['special_item']  === true ? $('#edtSpecialItem').text('TRUE') : $('#edtSpecialItem').text('FALSE');

            if (itemUpdate['type'] === 0) {
              $('#edtTypeItem').text('Quà');
            }
            else if (itemUpdate['type'] === 1) {
              $('#edtTypeItem').text('Thẻ Cào');
            }
            else {
              $('#edtTypeItem').text('NONE');
            }

          })
          .fail(() => {

          });
      });
    }

    function updateItem() {
      $('#btnEditItem').click(() => {

        let id          = $('#edtIdItem').val();
        let name        = $('#edtNameItem').val();
        let maximum     = $('#edtMaximumItem').val();
        let percent     = $('#edtPercentItem').val();

        if (id === '' || name === '' || maximum === '' || percent === '') {
          alert('Edit item failed!');
          return;
        }

        $.ajax({
          url         : 'http://' + window.location.host + '/api/v1/admin/setup/update-item',
          method      : 'POST',
          contentType : 'application/json; charset=utf-8',
          data        : JSON.stringify({
            id        : id,
            name      : name,
            maximum   : maximum,
            percent   : percent
          })
        })
          .done((data) => {

            if (data['status_code'] !== 2000) {
              alert(data['error']);
              return;
            }

            $('#modalEditItem').modal('hide');
            updateTableItem(data['lsItemUpdate']);

          })
          .fail(() => {

          });

      });
    }

  </script>

<%- include('../layouts/footer') %>